CREATE SCHEMA Historisierung

-- Historie:
--
-- 03.09.2003 - 1.005 (1.008)
-- Ereignis optional im historischen Objekt
--
-- 31.05.2002 - 1.004 (1.007)
-- Erweiterung der Wertebereiche von Meter, Kilometer und Jahr,
-- einige Subtypen von historisches_Objekt entfernt
--
-- 24.10.2001 - 1.003 (1.005)
-- Korrektur im Teilabschnitt_IdNT
--
-- 12.09.2001 - 1.002 (1.004)
-- Vermessungspunkt als Subtyp von historisches_Objekt ergnzt
--
-- 17.12.2000 - 1.001 (1.002)
-- Integration symbolischer Verweise fr
-- Abschnitt_oder_Ast und Strassenbaudienststelle
--
-- 15.10.1999 - 1.000 (1.000)
-- Erste Version des OKSTRA verabschiedet

CREATE TABLE historisches_Objekt (
   historisches_Objekt_ID
      INTEGER NOT NULL PRIMARY KEY,
   Art_historisches_Objekt
      INTEGER NOT NULL REFERENCES Art_historisches_Objekt,
   erzeugt_von_Ereignis
      INTEGER REFERENCES Ereignis,
   geloescht_von_Ereignis
      INTEGER REFERENCES Ereignis,
   hat_Vorgaenger_hist_Objekt
      INTEGER REFERENCES historisches_Objekt
)

CREATE TABLE Art_historisches_Objekt (
   Kennung
      INTEGER NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(30) NOT NULL
)

INSERT INTO Art_historisches_Objekt VALUES ( 1003, 'Strasse' )
INSERT INTO Art_historisches_Objekt VALUES ( 1007, 'Strasse_Netzknoten' )
INSERT INTO Art_historisches_Objekt VALUES ( 1011, 'Netzknoten' )
INSERT INTO Art_historisches_Objekt VALUES ( 1014, 'BAB_Knotennummer' )
INSERT INTO Art_historisches_Objekt VALUES ( 1019, 'Abschnitt' )
INSERT INTO Art_historisches_Objekt VALUES ( 1020, 'Ast' )
INSERT INTO Art_historisches_Objekt VALUES ( 1021, 'Verkehrliche_Verknuepfung' )
INSERT INTO Art_historisches_Objekt VALUES ( 1022, 'Nullpunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 1039, 'Netzbereich' )
INSERT INTO Art_historisches_Objekt VALUES ( 1051, 'Strecke' )
INSERT INTO Art_historisches_Objekt VALUES ( 1052, 'Strecke_SO' )
INSERT INTO Art_historisches_Objekt VALUES ( 1054, 'Teilnetz' )
INSERT INTO Art_historisches_Objekt VALUES ( 1056, 'Route' )
INSERT INTO Art_historisches_Objekt VALUES ( 1057, 'Strassenelement' )
INSERT INTO Art_historisches_Objekt VALUES ( 1058, 'Kilometrierung' )
INSERT INTO Art_historisches_Objekt VALUES ( 1060, 'Block' )
INSERT INTO Art_historisches_Objekt VALUES ( 2005, 'Bundesland' )
INSERT INTO Art_historisches_Objekt VALUES ( 2006, 'Regierungsbezirk' )
INSERT INTO Art_historisches_Objekt VALUES ( 2007, 'Kreis_kreisfreie_Stadt' )
INSERT INTO Art_historisches_Objekt VALUES ( 2009, 'Gemeindebezirk' )
INSERT INTO Art_historisches_Objekt VALUES ( 2012, 'Ortsteil' )
INSERT INTO Art_historisches_Objekt VALUES ( 2016, 'Land_Ministerium' )
INSERT INTO Art_historisches_Objekt VALUES ( 2017, 'Regierungspraesidium_Landesamt' )
INSERT INTO Art_historisches_Objekt VALUES ( 2018, 'Amt' )
INSERT INTO Art_historisches_Objekt VALUES ( 2019, 'Meisterei' )
INSERT INTO Art_historisches_Objekt VALUES ( 2020, 'Kreisverwaltung' )
INSERT INTO Art_historisches_Objekt VALUES ( 2021, 'Gemeindeverwaltung' )
INSERT INTO Art_historisches_Objekt VALUES ( 2022, 'sonstige_UI_Partner' )
INSERT INTO Art_historisches_Objekt VALUES ( 2023, 'UI_Vereinbarung' )
INSERT INTO Art_historisches_Objekt VALUES ( 2025, 'Baulast' )
INSERT INTO Art_historisches_Objekt VALUES ( 2030, 'OD_FS' )
INSERT INTO Art_historisches_Objekt VALUES ( 2032, 'Widmung' )
INSERT INTO Art_historisches_Objekt VALUES ( 3001, 'Fahrstreifen_Nummer' )
INSERT INTO Art_historisches_Objekt VALUES ( 3007, 'max_Hoehe' )
INSERT INTO Art_historisches_Objekt VALUES ( 3016, 'Fkt_d_Verb_im_Knotenpktber' )
INSERT INTO Art_historisches_Objekt VALUES ( 4001, 'Schicht' )
INSERT INTO Art_historisches_Objekt VALUES ( 4002, 'Schichtbegrenzung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4003, 'Schichtart' )
INSERT INTO Art_historisches_Objekt VALUES ( 4004, 'Schichtmaterial' )
INSERT INTO Art_historisches_Objekt VALUES ( 4005, 'Querschnittstreifen' )
INSERT INTO Art_historisches_Objekt VALUES ( 4006, 'Streifenart' )
INSERT INTO Art_historisches_Objekt VALUES ( 4007, 'Streifenbegrenzung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4008, 'Bauklasse_Oberbau' )
INSERT INTO Art_historisches_Objekt VALUES ( 4009, 'Bauweise_Oberbau' )
INSERT INTO Art_historisches_Objekt VALUES ( 4010, 'Regelquerschnitt' )
INSERT INTO Art_historisches_Objekt VALUES ( 4011, 'Bahnigkeit' )
INSERT INTO Art_historisches_Objekt VALUES ( 4013, 'Fahrbahnlaengsneigung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4014, 'Fahrbahnquerneigung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4020, 'Schutzzone' )
INSERT INTO Art_historisches_Objekt VALUES ( 4021, 'Hindernis' )
INSERT INTO Art_historisches_Objekt VALUES ( 4024, 'Gewaesserkreuzung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4025, 'Bahnkreuzung' )
INSERT INTO Art_historisches_Objekt VALUES ( 4028, 'Kreuzung_Strasse_Weg' )
INSERT INTO Art_historisches_Objekt VALUES ( 4032, 'Fussgaengerueberweg' )
INSERT INTO Art_historisches_Objekt VALUES ( 4034, 'Durchlass' )
INSERT INTO Art_historisches_Objekt VALUES ( 4035, 'Baustoff' )
INSERT INTO Art_historisches_Objekt VALUES ( 4036, 'Profil' )
INSERT INTO Art_historisches_Objekt VALUES ( 5003, 'Nebenanlage' )
INSERT INTO Art_historisches_Objekt VALUES ( 5005, 'Rastanlage_nicht_bew' )
INSERT INTO Art_historisches_Objekt VALUES ( 5006, 'Rastanlage_bew' )
INSERT INTO Art_historisches_Objekt VALUES ( 5007, 'Nebenbetrieb' )
INSERT INTO Art_historisches_Objekt VALUES ( 5008, 'Leitung' )
INSERT INTO Art_historisches_Objekt VALUES ( 5009, 'Leitungsverlauf' )
INSERT INTO Art_historisches_Objekt VALUES ( 5010, 'Leitungstraeger' )
INSERT INTO Art_historisches_Objekt VALUES ( 5011, 'Leitungsart' )
INSERT INTO Art_historisches_Objekt VALUES ( 5012, 'Markierung' )
INSERT INTO Art_historisches_Objekt VALUES ( 5014, 'Schutzplanke' )
INSERT INTO Art_historisches_Objekt VALUES ( 5016, 'entwaesserte_Fahrbahnflaeche' )
INSERT INTO Art_historisches_Objekt VALUES ( 5017, 'Lage_Entwaesserung' )
INSERT INTO Art_historisches_Objekt VALUES ( 5020, 'Art_der_Entwaesserung' )
INSERT INTO Art_historisches_Objekt VALUES ( 7004, 'Teilbauwerk' )
INSERT INTO Art_historisches_Objekt VALUES ( 7014, 'Bruecke' )
INSERT INTO Art_historisches_Objekt VALUES ( 7015, 'Verkehrszeichenbruecke' )
INSERT INTO Art_historisches_Objekt VALUES ( 7016, 'Tunnel_Trogbauwerk' )
INSERT INTO Art_historisches_Objekt VALUES ( 7017, 'Laermschutzbauwerk' )
INSERT INTO Art_historisches_Objekt VALUES ( 7018, 'Stuetzbauwerk' )
INSERT INTO Art_historisches_Objekt VALUES ( 7019, 'sonstiges_Bauwerk' )
INSERT INTO Art_historisches_Objekt VALUES ( 12001, 'automat_Dauerzaehlstelle' )
INSERT INTO Art_historisches_Objekt VALUES ( 12011, 'Zaehlgeraet' )
INSERT INTO Art_historisches_Objekt VALUES ( 12012, 'Erfassungsmerkmale_DZ' )
INSERT INTO Art_historisches_Objekt VALUES ( 12013, 'Detektoren_DZ' )
INSERT INTO Art_historisches_Objekt VALUES ( 12015, 'abgeleitete_Dauerzaehlstelle' )
INSERT INTO Art_historisches_Objekt VALUES ( 17001, 'manuelle_Zaehlstelle_SVZ' )
INSERT INTO Art_historisches_Objekt VALUES ( 17006, 'raeuml_Gueltigkeitsbereich_MZ' )
INSERT INTO Art_historisches_Objekt VALUES ( 18002, 'VBA_Wetterstation' )
INSERT INTO Art_historisches_Objekt VALUES ( 18003, 'SWIS_GMA_Messstelle' )
INSERT INTO Art_historisches_Objekt VALUES ( 20002, 'Kombination_von_Anlagentypen' )
INSERT INTO Art_historisches_Objekt VALUES ( 20007, 'SB_Anlagentyp' )
INSERT INTO Art_historisches_Objekt VALUES ( 20009, 'SB_Anzeigezustaende' )
INSERT INTO Art_historisches_Objekt VALUES ( 20010, 'SB_Wirkungsbereiche' )
INSERT INTO Art_historisches_Objekt VALUES ( 20014, 'WW_Anzeigezustaende' )
INSERT INTO Art_historisches_Objekt VALUES ( 20016, 'WW_Wirkungsbereiche' )
INSERT INTO Art_historisches_Objekt VALUES ( 20018, 'KB_Anlagentyp' )
INSERT INTO Art_historisches_Objekt VALUES ( 20020, 'KB_Anzeigezustaende' )
INSERT INTO Art_historisches_Objekt VALUES ( 20023, 'richtungsbezogener_WB' )
INSERT INTO Art_historisches_Objekt VALUES ( 20025, 'Angaben_zum_Knotenpunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 20027, 'Betriebsform' )
INSERT INTO Art_historisches_Objekt VALUES ( 20028, 'RW_Anzeigezustaende' )
INSERT INTO Art_historisches_Objekt VALUES ( 20029, 'RW_Wirkungsbereich' )
INSERT INTO Art_historisches_Objekt VALUES ( 20031, 'Art_der_Stromversorgung' )
INSERT INTO Art_historisches_Objekt VALUES ( 20034, 'manuelle_Steuerung' )
INSERT INTO Art_historisches_Objekt VALUES ( 20036, 'Datenuebertragungssystem' )
INSERT INTO Art_historisches_Objekt VALUES ( 20039, 'Unterzentrale' )
INSERT INTO Art_historisches_Objekt VALUES ( 20041, 'Verkehrsrechnerzentrale' )
INSERT INTO Art_historisches_Objekt VALUES ( 20043, 'Ueberwachung_der_Anlage' )
INSERT INTO Art_historisches_Objekt VALUES ( 20045, 'Wechselverkehrszeichen' )
INSERT INTO Art_historisches_Objekt VALUES ( 20047, 'Aufstellvorrichtung' )
INSERT INTO Art_historisches_Objekt VALUES ( 20048, 'Art_der_Aufstellung' )
INSERT INTO Art_historisches_Objekt VALUES ( 20050, 'Anzahl_der_Anzeigequerschnitte' )
INSERT INTO Art_historisches_Objekt VALUES ( 20052, 'Detektionsmethode' )
INSERT INTO Art_historisches_Objekt VALUES ( 20056, 'Art_der_Anordnung' )
INSERT INTO Art_historisches_Objekt VALUES ( 20058, 'Art_der_erfassten_Daten' )
INSERT INTO Art_historisches_Objekt VALUES ( 20059, 'Anzahl_der_Messquerschnitte' )
INSERT INTO Art_historisches_Objekt VALUES ( 21038, 'raeumlicher_Gueltigkeitsber' )
INSERT INTO Art_historisches_Objekt VALUES ( 21039, 'zeitlicher_Gueltigkeitsber' )
INSERT INTO Art_historisches_Objekt VALUES ( 22002, 'Rotlichtueberwachung' )
INSERT INTO Art_historisches_Objekt VALUES ( 22003, 'Angaben_zum_Knotenpunkt_LSA' )
INSERT INTO Art_historisches_Objekt VALUES ( 22005, 'Grundlage_und_Inbetriebn_daten' )
INSERT INTO Art_historisches_Objekt VALUES ( 22007, 'Angaben_zu_Verkehrsdaten' )
INSERT INTO Art_historisches_Objekt VALUES ( 22009, 'Signalprogrammparameter' )
INSERT INTO Art_historisches_Objekt VALUES ( 22010, 'hinterlegte_Programme' )
INSERT INTO Art_historisches_Objekt VALUES ( 22014, 'akust_oder_taktile_Signalgeber' )
INSERT INTO Art_historisches_Objekt VALUES ( 22016, 'Angaben_zum_Steuergeraet' )
INSERT INTO Art_historisches_Objekt VALUES ( 22018, 'Angaben_zur_Verkabelung' )
INSERT INTO Art_historisches_Objekt VALUES ( 22020, 'Angaben_z_Aufstellvorrichtung' )
INSERT INTO Art_historisches_Objekt VALUES ( 22021, 'optische_Signalgeber' )
INSERT INTO Art_historisches_Objekt VALUES ( 22022, 'Erfassungseinrichtungen_IV' )
INSERT INTO Art_historisches_Objekt VALUES ( 22023, 'Erfassungseinrichtungen_OeV' )
INSERT INTO Art_historisches_Objekt VALUES ( 22024, 'uebergeordnete_Zentrale' )
INSERT INTO Art_historisches_Objekt VALUES ( 26003, 'einfacher_Zeitraum' )
INSERT INTO Art_historisches_Objekt VALUES ( 26006, 'komplexer_Zeitraum' )
INSERT INTO Art_historisches_Objekt VALUES ( 29028, 'Lagefestpunkt_SBV' )
INSERT INTO Art_historisches_Objekt VALUES ( 29029, 'Lagepasspunkt_SBV' )
INSERT INTO Art_historisches_Objekt VALUES ( 29039, 'Hoehenfestpunkt_SBV' )
INSERT INTO Art_historisches_Objekt VALUES ( 29040, 'Hoehenpasspunkt_SBV' )
INSERT INTO Art_historisches_Objekt VALUES ( 29042, 'Aufnahmepunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 29043, 'Sicherungspunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 29044, 'sonstiger_Vermessungspunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 29046, 'trigonometrischer_Punkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 29051, 'Nivellementpunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 29053, 'Referenzstationspunkt' )
INSERT INTO Art_historisches_Objekt VALUES ( 32008, 'Baum' )
INSERT INTO Art_historisches_Objekt VALUES ( 32018, 'Bewuchs' )

CREATE TABLE Ereignis (
   Ereignis_ID
      INTEGER NOT NULL PRIMARY KEY,
   laufende_Nummer
      INTEGER NOT NULL,
   Wirksamkeitsdatum
      CHAR(10) NOT NULL, -- Datum
   CHECK ( Wirksamkeitsdatum LIKE '__.__.____' ),
   gehoert_zu_Projekt
      INTEGER REFERENCES Projekt_Strassenbau,
   hat_Dokument_zur_Erlaeuterung
      INTEGER REFERENCES Administration.Dokument
)

CREATE TABLE Ereignis__in_Bauamt (
   Ereignis
      INTEGER NOT NULL REFERENCES Ereignis,
   Strassenbaudienstst_abstr
      INTEGER NOT NULL REFERENCES Administration.Strassenbaudienstst_abstr
)

CREATE TABLE Projekt_Strassenbau (
   Projekt_Strassenbau_ID
      INTEGER NOT NULL PRIMARY KEY
)

CREATE TABLE identisches_Netzteil (
   identisches_Netzteil_ID
      INTEGER NOT NULL PRIMARY KEY,
   mit_Veraenderungsart
      CHAR(2) REFERENCES Veraenderungsart,
   war_Teilabschnitt
      INTEGER REFERENCES Teilabschnitt_IdNT,
   wurde_zu_Teilabschnitt
      INTEGER REFERENCES Teilabschnitt_IdNT,
   Teil_von_Ereignis
      INTEGER NOT NULL REFERENCES Ereignis,
   CHECK ( ( war_Teilabschnitt IS NOT NULL ) OR ( wurde_zu_Teilabschnitt IS NOT NULL ) )
)

CREATE TABLE Veraenderungsart (
   Kennung
      CHAR(2) NOT NULL PRIMARY KEY,
   Langtext
      VARCHAR(255) NOT NULL
)

INSERT INTO Veraenderungsart VALUES ('NB','Neubau')
INSERT INTO Veraenderungsart VALUES ('VB','Vollausbau')
INSERT INTO Veraenderungsart VALUES ('ZB','Zwischenausbau')
INSERT INTO Veraenderungsart VALUES ('RE','Rekultivierung')
INSERT INTO Veraenderungsart VALUES ('DT','Deckenerneuerung im Tiefeinbau')
INSERT INTO Veraenderungsart VALUES ('DH','Deckenerneuerung im Hocheinbau')
INSERT INTO Veraenderungsart VALUES ('WI','Widmung')
INSERT INTO Veraenderungsart VALUES ('AU','Aufstufung')
INSERT INTO Veraenderungsart VALUES ('AB','Abstufung')
INSERT INTO Veraenderungsart VALUES ('UM','Umnumerierung in der Straenbezeichnung')
INSERT INTO Veraenderungsart VALUES ('EZ','Einziehung')
INSERT INTO Veraenderungsart VALUES ('OD','Verlegung der OD-Grenze')
INSERT INTO Veraenderungsart VALUES ('UI','UI-Vertrag')
INSERT INTO Veraenderungsart VALUES ('GR','Grenzverlegung')
INSERT INTO Veraenderungsart VALUES ('SB','nderung der Abschnitts-/Astbezeichnung')
INSERT INTO Veraenderungsart VALUES ('LN','Lngennderung infolge Neumessung')
INSERT INTO Veraenderungsart VALUES ('KO','Korrektur')

CREATE TABLE Teilabschnitt_IdNT (
   Teilabschnitt_IdNT_ID
      INTEGER NOT NULL PRIMARY KEY,
   auf_Abschnitt_oder_Ast
      INTEGER NOT NULL REFERENCES Strassennetz.Abschnitt_oder_Ast_abstrakt,
   Station_1
      REAL NOT NULL, -- Meter
   Abstand_zur_Bestandsachse_1
      REAL, -- Meter
   Abstand_zur_Fahrbahnoberkante_1
      REAL, -- Meter
   Station_2
      REAL NOT NULL, -- Meter
   Abstand_zur_Bestandsachse_2
      REAL, -- Meter
   Abstand_zur_Fahrbahnoberkante_2
      REAL -- Meter
)

